;*** BINTOASC.M
;*** AUTOMGEN V5
;*** (C)opyright 1994 IRAI
;*** 29/07/1992
;***
;*** {?0} mot d'entre en binaire
;*** {?1} et {?2} mots de sortie en ascii
;***
;*** Ordre :
;*** {?1} contiendra les poids forts (deux premiers digits)
;*** {?2} contiendra les poids faibles (deux derniers digits)
;***
;*** Exemple:
;*** si {?0}=$12AB alors {?1}="12" et {?2}="AB"
;***


#LIBRARY bintoasc

        lda m120
        ana %0000000011110000
        rra 4
        jsr :bintoasc-convert:
        rla 8
        sta m58
        lda m120
        ana %0000000000001111
        jsr :bintoasc-convert:
        ora m58
        sta m122
        lda m120
        ana %1111000000000000
        rra 12
        jsr :bintoasc-convert:
        rla 8
        sta m58
        lda m120
        ana %0000111100000000
        rra 8
        jsr :bintoasc-convert:
        ora m58
        sta m121
        ret 0

:bintoasc-convert:
        sta m59
        ada 48 and m59<10
        ada 55 and m59>9
        sta m59
        ret m59

#ENDL


#MACRO

        lda {?0}
        sta m120
        jsr :bintoasc:
        lda m121
        sta {?1}
        lda m122
        sta {?2}

#ENDM



